'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _nouns = require('./nouns');

var _nouns2 = _interopRequireDefault(_nouns);

var _adjectives = require('./adjectives');

var _adjectives2 = _interopRequireDefault(_adjectives);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Generator = function () {
    function Generator() {
        _classCallCheck(this, Generator);
    }

    _createClass(Generator, [{
        key: 'generate',


        /**
         * Generate random project name.
         * 
         * @param {object} options 
         * @return {array}
         */
        value: function generate(options) {
            var defaults = { words: 2, number: false, alliterative: false };
            options = Object.assign(defaults, options);

            var raw = this.getRawProjName(options);

            this.projName = {
                raw: raw,
                spaced: raw.join(' '),
                dashed: raw.join('-')
            };

            return this;
        }

        /**
         * Get random project name.
         * 
         * @param {object} options 
         * @return {array}
         */

    }, {
        key: 'getRawProjName',
        value: function getRawProjName(options) {
            var raw = [];

            (0, _lodash.times)(options.words - 1, function () {
                raw.push((0, _lodash.sample)(_adjectives2.default).toLowerCase());
            });
            raw.push((0, _lodash.sample)(_nouns2.default).toLowerCase());
            if (options.number) {
                raw.push((0, _lodash.random)(1, 9999));
            }

            return raw;
        }

        /**
         * Get dashed project name.
         */

    }, {
        key: 'dashed',
        value: function dashed() {
            return this.projName.dashed;
        }

        /**
         * Get spaced project name.
         */

    }, {
        key: 'spaced',
        value: function spaced() {
            return this.projName.spaced;
        }

        /**
         * Get raw project name.
         */

    }, {
        key: 'raw',
        value: function raw() {
            return this.projName.raw;
        }
    }]);

    return Generator;
}();

var generator = new Generator();
exports.default = generator;